// TestVeryPdf.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include <windows.h>
#include <assert.h>
#include <stdio.h>

#define PDF2IMAGE_MODULE_NAME		("pdf2image.dll")

typedef void (__stdcall * pfnPDFToImageSetCode)(const char *lpRegcode);

typedef HBITMAP (__stdcall * pfnPDFToImageDrawToHDC)(
			const char * szPDFFileName,
			HDC hDC,
			const char * szUserPassword,
			const char * szOwnPassword,
			int xresolution,
			int yresolution,
			int iBitCount,
			BOOL bGrayscale,
			int iPageIndex);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL WriteBMPFile(HBITMAP bitmap, LPTSTR filename, HDC hDC)
{
	BITMAP bmp; 
	PBITMAPINFO pbmi; 
	WORD cClrBits; 
	HANDLE hf; // file handle 
	BITMAPFILEHEADER hdr; // bitmap file-header 
	PBITMAPINFOHEADER pbih; // bitmap info-header 
	LPBYTE lpBits; // memory pointer 
	DWORD dwTotal; // total count of bytes 
	DWORD cb; // incremental count of bytes 
	BYTE *hp; // byte pointer 
	DWORD dwTmp; 
	
	// create the bitmap info header information
	
	if (!GetObject(bitmap, sizeof(BITMAP), (LPSTR)&bmp))
	{
		MessageBox(GetDesktopWindow(), "Could not retrieve bitmap info", NULL, MB_OK);
		return FALSE;
	}
	
	// Convert the color format to a count of bits. 
	cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel); 
	if (cClrBits == 1) 
		cClrBits = 1; 
	else if (cClrBits <= 4) 
		cClrBits = 4; 
	else if (cClrBits <= 8) 
		cClrBits = 8; 
	else if (cClrBits <= 16) 
		cClrBits = 16; 
	else if (cClrBits <= 24) 
		cClrBits = 24; 
	else cClrBits = 32; 
	
	
	// Allocate memory for the BITMAPINFO structure.
	if (cClrBits != 24) 
		pbmi = (PBITMAPINFO) LocalAlloc(LPTR, 
		sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * (1<< cClrBits)); 
	else 
		pbmi = (PBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER)); 
	
	// Initialize the fields in the BITMAPINFO structure. 
	
	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
	pbmi->bmiHeader.biWidth = bmp.bmWidth; 
	pbmi->bmiHeader.biHeight = bmp.bmHeight; 
	pbmi->bmiHeader.biPlanes = bmp.bmPlanes; 
	pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel; 
	if (cClrBits < 24) 
		pbmi->bmiHeader.biClrUsed = (1<<cClrBits); 
	
	// If the bitmap is not compressed, set the BI_RGB flag. 
	pbmi->bmiHeader.biCompression = BI_RGB; 
	
	// Compute the number of bytes in the array of color 
	// indices and store the result in biSizeImage. 
	pbmi->bmiHeader.biSizeImage = (pbmi->bmiHeader.biWidth + 7) /8 * pbmi->bmiHeader.biHeight * cClrBits; 
	// Set biClrImportant to 0, indicating that all of the 
	// device colors are important. 
	pbmi->bmiHeader.biClrImportant = 0; 
	
	// now open file and save the data
	pbih = (PBITMAPINFOHEADER) pbmi; 
	lpBits = (LPBYTE) GlobalAlloc(GMEM_FIXED, pbih->biSizeImage);
	
	if (!lpBits)
	{
		MessageBox(GetDesktopWindow(), "writeBMP::Could not allocate memory", NULL, MB_OK);
		return FALSE;
	}
	
	// Retrieve the color table (RGBQUAD array) and the bits 
	if (!GetDIBits(hDC, HBITMAP(bitmap), 0, (WORD) pbih->biHeight, lpBits, pbmi, DIB_RGB_COLORS))
	{
		MessageBox(GetDesktopWindow(), "writeBMP::GetDIB error", NULL, MB_OK);
		return FALSE;
	}
	
	// Create the .BMP file. 
	hf = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, (DWORD) 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 
		(HANDLE) NULL); 
	if (hf == INVALID_HANDLE_VALUE)
	{
		MessageBox(GetDesktopWindow(), "Could not create file for writing", NULL, MB_OK);
		return FALSE;
	}
	hdr.bfType = 0x4d42; // 0x42 = "B" 0x4d = "M" 
	// Compute the size of the entire file. 
	hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
		pbih->biSize + pbih->biClrUsed 
		* sizeof(RGBQUAD) + pbih->biSizeImage); 
	hdr.bfReserved1 = 0; 
	hdr.bfReserved2 = 0; 
	
	// Compute the offset to the array of color indices. 
	hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
		pbih->biSize + pbih->biClrUsed 
		* sizeof (RGBQUAD); 
	
	// Copy the BITMAPFILEHEADER into the .BMP file. 
	if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER), 
		(LPDWORD) &dwTmp, NULL))
	{
		MessageBox(GetDesktopWindow(), "Could not write in to file", NULL, MB_OK);
		return FALSE;
	}
	
	// Copy the BITMAPINFOHEADER and RGBQUAD array into the file. 
	if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER) 
		+ pbih->biClrUsed * sizeof (RGBQUAD), 
		(LPDWORD) &dwTmp, ( NULL)))
	{
		MessageBox(GetDesktopWindow(), "Could not write in to file", NULL, MB_OK);
		return FALSE;
	}
	
	
	// Copy the array of color indices into the .BMP file. 
	dwTotal = cb = pbih->biSizeImage; 
	hp = lpBits; 
	if (!WriteFile(hf, (LPSTR) hp, (int) cb, (LPDWORD) &dwTmp,NULL))
	{
		MessageBox(GetDesktopWindow(), "Could not write in to file", NULL, MB_OK);
		return FALSE;
	}
	
	// Close the .BMP file. 
	if (!CloseHandle(hf))
	{
		MessageBox(GetDesktopWindow(), "Could not close file", NULL, MB_OK);
		return FALSE;
	}
	
	// Free memory. 
	GlobalFree((HGLOBAL)lpBits);
	return TRUE;
}

BOOL TestPdf(const char* pdf_filename, const char* bmp_filename)
{
	BOOL bRet = FALSE;
	char szLibPath[_MAX_PATH];
	GetModulePath(szLibPath, PDF2IMAGE_MODULE_NAME);
	HMODULE dll_handle = LoadLibrary(szLibPath);
	if(dll_handle == NULL)
		return FALSE;
	pfnPDFToImageSetCode PDFToImageSetCode = (pfnPDFToImageSetCode)GetProcAddress(dll_handle, "PDFToImageSetCode");
	if(PDFToImageSetCode)
		PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXX");
	pfnPDFToImageDrawToHDC PDFToImageDrawToHDC = (pfnPDFToImageDrawToHDC)GetProcAddress(dll_handle, "PDFToImageDrawToHDC");
	if(PDFToImageDrawToHDC)
	{
		HDC hdc = CreateCompatibleDC(NULL);
		HBITMAP hbm = PDFToImageDrawToHDC(pdf_filename, NULL, "", "", 200, 200, 24, FALSE, 1);
		bRet = WriteBMPFile(hbm, (char*)bmp_filename, hdc);
		DeleteDC(hdc);
	}
	FreeLibrary(dll_handle);
	return TRUE;
}

int main(int argc, char* argv[])
{
	if(argc != 3)
	{
		printf("%s test.pdf out.bmp\n", argv[0]);
		return 0;
	}
	int nTime1 = GetTickCount();
	TestPdf(argv[1], argv[2]);
	int nTime2 = GetTickCount();
	printf("Time = %dms (%.2fs)\n",nTime2-nTime1, (nTime2-nTime1)/1000.0);
	return 0;
}

